class OpenPWS {
  Response response;

  OpenPWS({this.response});

  OpenPWS.fromJson(Map<String, dynamic> json) {
    response = json['response'] != null
        ? new Response.fromJson(json['response'])
        : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.response != null) {
      data['response'] = this.response.toJson();
    }
    return data;
  }
}

class Response {
  int respCode;
  Output output;

  Response({this.respCode, this.output});

  Response.fromJson(Map<String, dynamic> json) {
    respCode = json['respCode'];
    output =
    json['output'] != null ? new Output.fromJson(json['output']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['respCode'] = this.respCode;
    if (this.output != null) {
      data['output'] = this.output.toJson();
    }
    return data;
  }
}

class Output {
  Session session;
  List<Pages> pages;

  Output({this.session, this.pages});

  Output.fromJson(Map<String, dynamic> json) {
    session =
    json['session'] != null ? new Session.fromJson(json['session']) : null;
    if (json['pages'] != null) {
      pages = new List<Pages>();
      json['pages'].forEach((v) {
        pages.add(new Pages.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.session != null) {
      data['session'] = this.session.toJson();
    }
    if (this.pages != null) {
      data['pages'] = this.pages.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class Session {
  String id;
  String validity;
  String baseURL;
  String firstName;
  String lastName;
  String userGroup;
  String linkedUsrRef;
  String linkedUsrNo;
  String sipID;
  String profilePicture;
  String linkedUserFName;
  String linkedUserLName;
  String linkedUserProfilePic;
  String title;
  String locTrackingFreq;
  AddlInfo addlInfo;
  String phoneUserID;
  String tmplt;

  Session(
      {this.id,
        this.validity,
        this.baseURL,
        this.firstName,
        this.lastName,
        this.userGroup,
        this.linkedUsrRef,
        this.linkedUsrNo,
        this.sipID,
        this.profilePicture,
        this.linkedUserFName,
        this.linkedUserLName,
        this.linkedUserProfilePic,
        this.title,
        this.locTrackingFreq,
        this.addlInfo,
        this.phoneUserID,
        this.tmplt});

  Session.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    validity = json['validity'];
    baseURL = json['baseURL'];
    firstName = json['firstName'];
    lastName = json['lastName'];
    userGroup = json['userGroup'];
    linkedUsrRef = json['linkedUsrRef'];
    linkedUsrNo = json['linkedUsrNo'];
    sipID = json['sipID'];
    profilePicture = json['profilePicture'];
    linkedUserFName = json['linkedUserFName'];
    linkedUserLName = json['linkedUserLName'];
    linkedUserProfilePic = json['linkedUserProfilePic'];
    title = json['title'];
    locTrackingFreq = json['locTrackingFreq'];
    addlInfo = json['addlInfo'] != null
        ? new AddlInfo.fromJson(json['addlInfo'])
        : null;
    phoneUserID = json['phoneUserID'];
    tmplt = json['tmplt'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['validity'] = this.validity;
    data['baseURL'] = this.baseURL;
    data['firstName'] = this.firstName;
    data['lastName'] = this.lastName;
    data['userGroup'] = this.userGroup;
    data['linkedUsrRef'] = this.linkedUsrRef;
    data['linkedUsrNo'] = this.linkedUsrNo;
    data['sipID'] = this.sipID;
    data['profilePicture'] = this.profilePicture;
    data['linkedUserFName'] = this.linkedUserFName;
    data['linkedUserLName'] = this.linkedUserLName;
    data['linkedUserProfilePic'] = this.linkedUserProfilePic;
    data['title'] = this.title;
    data['locTrackingFreq'] = this.locTrackingFreq;
    if (this.addlInfo != null) {
      data['addlInfo'] = this.addlInfo.toJson();
    }
    data['phoneUserID'] = this.phoneUserID;
    data['tmplt'] = this.tmplt;
    return data;
  }
}

class AddlInfo {
  String sDe1;
  String sDe2;
  String sDe3;
  String sDe4;
  String sDe5;
  String sDe6;
  String sDe7;
  String sDe8;
  String sDe9;
  String sDe10;
  String sRa1;
  String sRa2;
  String sRa3;
  String sRa4;
  String sRa5;
  String sRa6;
  String sRa7;
  String sRa8;
  String sRa9;
  String sRa10;

  AddlInfo(
      {this.sDe1,
        this.sDe2,
        this.sDe3,
        this.sDe4,
        this.sDe5,
        this.sDe6,
        this.sDe7,
        this.sDe8,
        this.sDe9,
        this.sDe10,
        this.sRa1,
        this.sRa2,
        this.sRa3,
        this.sRa4,
        this.sRa5,
        this.sRa6,
        this.sRa7,
        this.sRa8,
        this.sRa9,
        this.sRa10});

  AddlInfo.fromJson(Map<String, dynamic> json) {
    sDe1 = json['_de1'];
    sDe2 = json['_de2'];
    sDe3 = json['_de3'];
    sDe4 = json['_de4'];
    sDe5 = json['_de5'];
    sDe6 = json['_de6'];
    sDe7 = json['_de7'];
    sDe8 = json['_de8'];
    sDe9 = json['_de9'];
    sDe10 = json['_de10'];
    sRa1 = json['_ra1'];
    sRa2 = json['_ra2'];
    sRa3 = json['_ra3'];
    sRa4 = json['_ra4'];
    sRa5 = json['_ra5'];
    sRa6 = json['_ra6'];
    sRa7 = json['_ra7'];
    sRa8 = json['_ra8'];
    sRa9 = json['_ra9'];
    sRa10 = json['_ra10'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['_de1'] = this.sDe1;
    data['_de2'] = this.sDe2;
    data['_de3'] = this.sDe3;
    data['_de4'] = this.sDe4;
    data['_de5'] = this.sDe5;
    data['_de6'] = this.sDe6;
    data['_de7'] = this.sDe7;
    data['_de8'] = this.sDe8;
    data['_de9'] = this.sDe9;
    data['_de10'] = this.sDe10;
    data['_ra1'] = this.sRa1;
    data['_ra2'] = this.sRa2;
    data['_ra3'] = this.sRa3;
    data['_ra4'] = this.sRa4;
    data['_ra5'] = this.sRa5;
    data['_ra6'] = this.sRa6;
    data['_ra7'] = this.sRa7;
    data['_ra8'] = this.sRa8;
    data['_ra9'] = this.sRa9;
    data['_ra10'] = this.sRa10;
    return data;
  }
}

class Pages {
  String tmplt;
  String title;
  String desc;
  String srvContext;
  String imgRef;
  List<Services> services;

  Pages(
      {this.tmplt,
        this.title,
        this.desc,
        this.srvContext,
        this.imgRef,
        this.services});

  Pages.fromJson(Map<String, dynamic> json) {
    tmplt = json['tmplt'];
    title = json['title'];
    desc = json['desc'];
    srvContext = json['srvContext'];
    imgRef = json['imgRef'];
    if (json['services'] != null) {
      services = new List<Services>();
      json['services'].forEach((v) {
        services.add(new Services.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['tmplt'] = this.tmplt;
    data['title'] = this.title;
    data['desc'] = this.desc;
    data['srvContext'] = this.srvContext;
    data['imgRef'] = this.imgRef;
    if (this.services != null) {
      data['services'] = this.services.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class Services {
  String title;
  String desc;
  String ref;
  String srvRef;
  String request;
  String imgRef;

  Services(
      {this.title,
        this.desc,
        this.ref,
        this.srvRef,
        this.request,
        this.imgRef});

  Services.fromJson(Map<String, dynamic> json) {
    title = json['title'];
    desc = json['desc'];
    ref = json['ref'];
    srvRef = json['srvRef'];
    request = json['request'];
    imgRef = json['imgRef'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['title'] = this.title;
    data['desc'] = this.desc;
    data['ref'] = this.ref;
    data['srvRef'] = this.srvRef;
    data['request'] = this.request;
    data['imgRef'] = this.imgRef;
    return data;
  }
}
